#!/usr/bin/env/python
# -*- coding:utf-8 -*-
"""
单题再解析、结构化
"""
import re

from structure.option import option_structure
from structure.final_structure import one_item_structure
from utils.equation_extract import get_simpstr2eqn, get_equation_instr
from utils.html_again_parse import css_label_wash
from utils.washutil import base642img, css_conflict_deal, wash_after, convert_huanhang
from structure.three_parse_structure import *


def single_parse(one_item, item_type, wordid, subject):
    """
    rtype:题型
    :return:
    """
    # if re.search("选择|不定选择|多选|单选", rtype):
    #     if "【选项】" not in one_item:
    #         return "请不要将本编辑框自带的“【选项】、【答案】、【解析】”字段删除"
    # if "【答案】" not in one_item or "【解析】" not in one_item:
    #     return "请不要将本编辑框自带的“【答案】、【解析】”字段删除"
    print("原始：")
    # print(one_item)
    one_item = css_label_wash(one_item)
    one_item = re.sub(r"<p>(<p style=)", r"\1", one_item)
    one_item = re.sub("</?p>|<h[12345]", "", one_item)

    one_item = base642img(one_item, wordid)
    print("去css：")
    # print(one_item)
    # one_item = css_conflict_deal(one_item)
    print("<清洗：")
    # print(one_item)
    one_item = re.sub(r"\\\(\s*{\s*\}\s*\\\)", "", one_item)
    one_item = re.sub(r"\\\(\s*\\\)", "", one_item)
    one_item = re.sub(r"\\\(|\\\)", "$", one_item)
    one_item = re.sub(r"【\d{1,2}题详解】", "【详解】", one_item)

    res_list = re.split(r"(\n+【答案】|\n+【解析】)", one_item)
    if len(res_list) > 5:
        return "编辑后的文本出现多个【答案】或【解析】字段，请删除，每个字段只保留唯一且单独成行"
    elif len(res_list) < 5:
        res_list = re.split(r"(【答案】|【解析】)", one_item)
        if len(res_list) > 5:
            return "编辑后的文本出现多个【答案】或【解析】字段，请删除，每个字段只保留唯一且单独成行"
        # elif len(res_list) < 5:
        #     return "编辑后的文本掉了【答案】或【解析】字段，请添加，每个字段保留唯一"

    item_type_head = ""
    if "【题型】" in res_list[0]:
        item_type_line_info = re.search("^\s*【题型】.{,10}\s*?\n", res_list[0])
        if item_type_line_info:
            item_type_line = res_list[0][:item_type_line_info.end()]
            item_type_head = re.sub("【题型】\s*[:：]", "", item_type_line).rstrip()
            res_list[0] = res_list[0][item_type_line_info.end():].rstrip()
    new_item_struct = {"key": "", "parse": "", "stem": res_list[0]}

    if len(res_list) == 5:
        if res_list[1].strip() == "【答案】" and res_list[3].strip() == "【解析】":
            new_item_struct["key"] = res_list[2]
            new_item_struct["parse"] = res_list[4]
        elif res_list[1].strip() == "【解析】" and res_list[3].strip() == "【答案】":
            new_item_struct["key"] = res_list[4]
            new_item_struct["parse"] = res_list[2]
        else:
            return "编辑后的文本出现多个【答案】或【解析】字段，请修改，每个字段只保留唯一且单独成行"
    elif len(res_list) > 2:
        if res_list[1].strip() == "【答案】":
            new_item_struct["key"] = res_list[2]
        elif res_list[1].strip() == "【解析】":
            new_item_struct["parse"] = res_list[2]

    # 选项再解析
    new_item_struct["errmsgs"] = []
    if re.search("小题多问", item_type):
        if len(new_item_struct["stem"].strip()) < 3:
            return "题干为空，请补充完整"
        row_list = re.split(r"\n+", "\n".join(res_list))
        item_list, _, item_groups, ans_groups = split_by_topicno(row_list, subject, 1)
        # pprint(item_list)

        if not item_list:
            print("=======没有题号，一题多问题目=============")
            new_item_struct["type"] = item_type
            item_ids = re.findall("^\s*([1-5][0-9]|[1-9])\s*[.．、､]", new_item_struct["stem"].rstrip())
            new_item_struct["item_id"] = 1
            if item_ids:
                new_item_struct["item_id"] = item_ids[0]
            item_list = [new_item_struct]

        elif subject not in ["语文", "地理"] and len(item_list) > 1:  # 2022.2.24
            subject = "地理"
            item_list, _, item_groups, ans_groups = split_by_topicno(row_list, subject, 1)

        items_n = len(item_list)
        xyz = zip(item_list, ['toslave'] * items_n, [1] * items_n, [subject] * items_n, [1] * items_n)
        res = list(map(one_item_structure, xyz))
        # pprint(res)
        # print("item_groups:", item_groups)
        # print("ans_groups:", ans_groups)
        if len(item_list) == 1:
            item_groups = {}
        res = wash_after(res, item_groups, ans_groups, subject)
        if type(res) == list and len(res) == 1:
            res = res[0]
            res["type"] = "小题多问类"
        # pprint(res)
        return res
    else:  # 解答类、选择类
        item_ids = re.findall("^\s*([1-5][0-9]|[1-9])\s*[.．、､]", new_item_struct["stem"].rstrip())
        new_item_struct["stem"] = re.sub("^\s*([1-5][0-9]|[1-9])\s*[.．、､]", "", new_item_struct["stem"].rstrip())
        if len(new_item_struct["stem"].strip()) < 3:
            return "题干为空，请补充完整"

        if re.search("选择|不定选择|多选|单选", item_type):
            new_item_struct = option_structure(new_item_struct, res_list[0], new_item_struct["key"], 1, 1)
            if new_item_struct["errmsgs"]:
                return ";;".join(new_item_struct["errmsgs"])
            if 'options' in new_item_struct and any([True for i in new_item_struct['options'] if not i.replace("：", "").strip()]):  # 空选项中：被当成了内容
                return "存在选项为空，请补充完整"

        new_item_struct["topic_num"] = item_ids[0] if item_ids else 0
        # 换行符替换
        # new_item_struct["stem"] = new_item_struct["stem"].rstrip().replace("\n\n", "\n").replace("\n", "<br/>")  # 2020/4/10 gai
        # new_item_struct["key"] = new_item_struct["key"].strip().replace("\n\n", "\n").replace("\n", "<br/>")
        # new_item_struct["parse"] = new_item_struct["parse"].strip().replace("\n\n", "\n").replace("\n", "<br/>")

        if "key" not in new_item_struct:
            new_item_struct["key"] = ""
        if "parse" not in new_item_struct:
            new_item_struct["parse"] = ""
        if "options" in new_item_struct:  # 对选项部分进行格式处理  get_equation_instr
            # for i in range(len(new_item_struct['options'])):
            #     new_item_struct['options'][i] = new_item_struct['options'][i].strip().replace("\n\n", "\n")\
            #                                                     .replace("\n", "<br/>")
            new_item_struct["type"] = "选择类"
            new_item_struct["answer_type"] = "选择题"
        else:
            new_item_struct["type"] = "解答类"
            blank_num = len(re.findall(r"_{2,}", new_item_struct["stem"]))
            if blank_num > 0:
                new_item_struct["blank_num"] = blank_num
                new_item_struct["answer_type"] = "填空题"
            elif re.search("[(（]\s+[）)]\s*$", new_item_struct["stem"]):
                new_item_struct["answer_type"] = "判断题"
            elif re.search("书面表达|写一篇文章|作文题目", new_item_struct["stem"]):
                new_item_struct["answer_type"] = "语文作文"
            else:
                new_item_struct["answer_type"] = "解答题"

            # ind_label = '<p style="text-indent: 2em">'
            if "【范文】" in new_item_struct['key']:  # "写作"
                if "语文" in subject:
                    new_item_struct["answer_type"] = "语文作文"
                # anss = re.split("<br/>", new_item_struct['key'])
                # ids = [n for n, a in enumerate(anss) if "【范文】" in a][0]
                # may_title = anss[ids].replace("【范文】", "").strip()
                # if not may_title:
                #     ids += 1
                # may_title = anss[ids].strip()
                # if 0 < len(may_title) < 5:
                #     new_ans = "<br/>".join(anss[:ids]) + '<p style="text-align:center">'+anss[ids]+"</p>" \
                #              + ind_label + ('</p>'+ind_label).join(anss) + "</p>"
                # else:
                #     new_ans = ind_label + '</p><p style="text-indent: 2em">'.join(anss) + "</p>"
                # new_item_struct['key'] = new_ans
            # elif re.search("阅读.{,4}材料", new_item_struct['stem']) and "text-indent:" not in new_item_struct['stem']:
            #     new_item_struct['stem'] = suojin(new_item_struct['stem'])
        convert_huanhang(new_item_struct)
        # print(new_item_struct)
        return new_item_struct


def suojin(item_str):
    """
    文本缩进处理
    :param item_str:
    :return:
    """
    ind_label = '<p style="text-indent: 2em">'
    con_list = re.split("\n+", item_str.strip())
    new_con = ind_label + ('</p>' + ind_label).join(con_list) + "</p>"
    new_con = re.sub(r'<p style="text-indent: 2em">(\s*<img .+?)</p>($|<p style="text-indent: 2em">)',
                     r'\n\1\n\2', new_con, flags=re.S).strip()
    return new_con


if __name__ == '__main__':
    html = '''
<p>2021年，北京中轴线申请世界文化遗产工作进入关键阶段，已确定了包括天安门、正阳门、天坛在内的14个遗产点。学校组织了“中轴线上多彩明珠”展示活动，你所在班级负责制作宣传正阳门的短片。</p>
<p>1. 短片第一部分，介绍正阳门在历史上的重要功用。下面是同学们找到的一则材料。</p>
<p>正阳门曾是国家的礼仪之门。作为明清两代都城的正门，正阳门在京师诸门中规制最高。皇帝每年去天坛祭天和到先农坛亲耕，都要通过正阳门。所谓“正阳门走龙车”，就是指此门只供皇帝出入。</p>
<p>正阳门还曾是京师锁钥。当时的正阳门包括城楼、箭楼、瓮城、闸楼，它们形成了严密的军事防御系统：城楼供守城将领登高瞭望，指挥作战；箭楼在城楼正前方，开有箭窗，用于防御、射击；瓮城将城楼与箭楼连为一体，形成对城门的保护；闸楼则建于瓮城之上，其门洞上方的千斤闸重约1990公斤，在敌军进犯时可起到重要防御作用。</p>
<p>（1）短片第一部分要从以下两幅字中选择一幅作片头，来体现正阳门的特点。请你选择并说明理由。</p>
<p><img src="files/image1.png" width="508px" height="88px" /></p>
<p>甲                           乙</p>
<p>选择：____________</p>
<p>理由：____________</p>
<p>（2）同学们在《古代汉语词典》中查到“钥”的义项有：①锁；②钥匙；③闭锁，关闭。根据文段内容及词典释义，你认为“锁钥”在这里的意思是（       ）</p>
<p>【甲】进入京城的通道    【乙】军事防御屏障    【丙】沉重的千斤闸</p>
<p>2. 短片第二部分，讲述正阳门的沧桑历史。下面是同学们写的文字稿，请帮他们解决在配音和制作字幕过程中遇到的问题。</p>
<p>正阳门的前身是元大都的丽正门，明代改名为正阳门，距今已有六百多年的历史。</p>
<p>明末，起义军兵临北京，正阳门的守卫弃城投降，沉重的千斤闸形同虚设，①____清末，厚重的城墙没挡住八国联军的枪炮，在城楼上设岗巡逻的竟已是外国士兵。那时在民间流传的歌谣“今日正阳门左右，外人随意立高墙”，诉说的正是这段屈辱的历史，②_____在很长一段时间里，正阳门都笼罩在战争的阴霾之下。曾经的礼仪之门失去了皇家威严，曾经的防御系统也土崩瓦解。龙车凤辇、黄柄华盖的洪大场面已经消失，原来只有皇帝通行才能开启的正阳门，悄然融入了普通人的生活。</p>
<p>1949年，北平和平解放，正阳门箭楼高挂“欢迎人民解放军”的红色标语。在飘扬的红旗和热情的欢呼声中，正阳门翻开了新的一页。</p>
<p>（1）有同学对①②两处使用的标点符号有疑问，你认为这两处的标点符号使用正确的是（       ）</p>
<p>A.①；②。     B.①；②，</p>
<p>C.①。②。     D.①。②，</p>
<p>（2）有同学认为画线词语中有错别字，对加点字的读音也有疑问。下列判断错误的一项是（       ）</p>
<p>A.“流传”应写为“留传”     B.“笼”应读为“lǒng”</p>
<p>C.“洪大”应写为“宏大”     D.“悄”应读为“qiǎo”</p>
<p>（3）根据语境，画波浪线的句子表达欠妥，请修改。（2分）</p>
<p>修改：__________________</p>
<p>3. 短片第三部分，是同学们制作的“我眼中的正阳门”采访视频。下列四位被采访者说话时用了成语或修辞方法，其中不恰当的一项是（   ）</p>
<p>A. 游客：“登上正阳门，我的敬意油然而生。古人太聪明了，城楼既坚固又美观。城砖的灰、城门的红、琉璃屋顶的绿和彩绘的金，搭配多和谐啊！”</p>
<p>B. 生态保护志愿者：“正阳门是北京雨燕的重要栖息地。每年3月雨燕都会和正阳门不期而遇，8月它们又从正阳门飞往非洲，给远方捎去中国的消息。”</p>
<p>C. 附近居民：“老北京人管正阳门叫‘前门楼子’。前门大街是大家都爱逛的地方，到处是好玩的、好吃的，嗓子眼儿冒烟的时候来一碗大碗茶，舒服极了！”</p>
<p>D. 正阳门博物馆讲解员：“如今的正阳门作为北京历史文化的重要载体，伫立在北京中轴线上，诉说着昔日的荣光、过往的沧桑，成为一部土石写就的史书。”</p>
<p>4. 短片结尾，需要几位同学各用一种颜色表达对正阳门的理解。请你结合短片的内容，按照示例，仿写句子。</p>
<p>示例：我心目中的正阳门是绿色的。绿色既是城楼屋顶琉璃瓦的颜色，也是人与北京雨燕和谐相处的象征。</p>
<p>【答案】1.     ①. （1）示例一：选甲    ②. 甲是古朴的篆书，能体现正阳门古老的特点。    示例二：选乙  乙是端正的楷书，能体现正阳门端庄的特点。    ③. （2）乙    </p>
<p>2.     ①. （1）C    ②. （2）A    ③. （3）曾经的防御系统土崩瓦解，曾经的礼仪之门也失去了皇家威严。    3. B    </p>
<p>4. 示例：我心目中<img src="files/image2.png" width="14px" height="18px" data-latex="$$" />正阳门是灰色的。灰色既是城砖的颜色，也是正阳门沧桑历史的象征。</p>
<p>【解析】</p>
<p>【分析】</p>
<p>【1题详解】</p>
<p>（1）本题考查字体鉴赏。甲字体为小篆，是在秦始皇统一六国后创制的汉字书写形式；乙笔画端正，横平竖直，为正楷。根据字体的特点，结合正阳门的特点选择。选甲，小篆古朴，能体现正阳门古老的特点。选乙，楷书端正，能体现正阳门端庄的特点。</p>
<p>（2）本题考查结合语境理解词义。根据下文“当时的正阳门包括城楼、箭楼、瓮城、闸楼，它们形成了严密的军事防御系统”可知“锁钥”在这里的意思军事防御屏障。故选乙。</p>
<p>【2题详解】</p>
<p>（1）C.句号：用于陈述句末尾，表示一句话的结束。①处写“明末，起义军兵临北京，正阳门的守卫弃城投降，沉重的千斤闸形同虚设”，下一句写“清末”，因此可以判断前一句表达的意思已经结束，所以应该用句号。②处那时在民间流传的歌谣诉说的正是这段屈辱的历史，表达的意思完整，因此也应该用句号。故选C。</p>
<p>（2）A.句中“流传”是正确的。“流传”和“留传”的区别，“传”的范围不同。“流传”既是纵向的，指时间上的由前往后；又是横向的，指空间上的由此及彼。而“留传”只能是纵向的，它只能传下去，而不能传开来。句中形容歌谣的传播，“流传”没有错。故选A。</p>
<p>（3）本题考查病句的识别和修改。语序不当。将“曾经的礼仪之门失去了皇家威严”与“曾经的防御系统也土崩瓦解”调换位置。</p>
<p>【3题详解】</p>
<p>B.不期而遇：没有约定而遇见，指意外碰见。句中说每年3月雨燕都会来正阳门，就不是“意外碰见”。故选B。</p>
<p>【4题详解】</p>
<p>本题考查仿写。注意句式相同，内容相关。我心目中的正阳门是红色的。红色既是正阳门城门的颜色，也是北平和平解放人们迎来新希望的象征。</p>

    '''
    html1 = """
    <div class="stem-wraper" data-v-494b33d9=""><span class="stem" data-v-494b33d9=""><span style="color: #303133; font-family: 'Helvetica Neue', Helvetica, Arial, 'PingFang SC', 'Hiragino Sans GB', 'Heiti SC', 'Microsoft YaHei', 'WenQuanYi Micro Hei', sans-serif; background-color: #ffffff;">今年《开学第一课》以“理想照亮未来”为主题，讲述了中国共产党百年奋斗史中具有重大意义和深刻影响的故事，在央视综合频道播出后取得积极反响。据此完成下面小题。</span><br>8、节目回溯历史征程，立足中国实际，展望光明前景，彰显了中国共产党人的精神谱系，激发了青少年学生的自信与自强，引导青少年学生坚定理想信念、坚定奋斗意志、坚定恒心韧劲。这说明（ ）<br>①文化对人的影响来自于特定的文化环境和各种文化活动<br>②大众传媒已经成为文化传播、沟通、共享的重要途径<br>③要努力推动中华优秀传统文化创造性转化、创新性发展<br>④人在社会实践中创造文化，也在社会生活中享用文化<br>A. ①②B. ①④C. ②③D. ③④<br>9. 节目邀请了多位“七一勋章”获得者及革命烈士、时代楷模的后代讲述先进故事，还攻克技术难关把课堂搬上太空，与中国空间站进行“天地对话"，并借助戏剧化手段进行“时空穿越”看“小康”内涵演变，打造“沉浸式”课堂。节目借助各种手段打造“沉浸式”课堂（ ）<br>①说明多样化的艺术形式能够更好地彰显文化的价值<br>②旨在传承中华优秀传统文化，丰富文化内涵，增强文化自信<br>③有利于引导青年学生坚定理想信念，树立正确的历史观、国家观、民族观、文化观<br>④说明科技促使教育方式不断变革，在人的教化与培育上始终扮演重要角色<br>A. ①③B. ①④C. ②③D. ②④</span></div>
<div class="topic-analysis" data-v-494b33d9="">
<div class="topic-analysis-content" data-v-494b33d9=""><span class="analysis-prefix" data-v-494b33d9="">【答案】</span><span data-v-494b33d9="">B、A</span></div>
<div class="topic-analysis-content" data-v-494b33d9=""><span class="analysis-prefix" data-v-494b33d9="">【解析】</span><span data-v-494b33d9="">【详解】<br>①④：举办专题电视节目《开学第一课》，讲述中国共产党百年奋斗史中具有重大意义和深刻影响的故事，彰显了中国共产党人的精神谱系，激发了青少年学生的自信与自强，①④应选。<br>②：大众传媒是文化传播的主要手段，不是文化传播的重要途径，②不选。<br>③：材料并未涉及优秀传统文化的创造性转化、创新性发展，③与题意无关，不选。<br>故本题选B。<br>【详解】<br>①③：借助技术手段和多种艺术手法打造“沉浸式”课堂，生动诠释了伟大建党精神，也激发了青少年学生的自信与自强，能够更好地彰显文化的价值，有利于引导青年学生坚定理想信念，树立正确的历史观、国家观、民族观、文化观，①③应选。<br>②：材料体现的是弘扬革命文化，打造“沉浸式”课堂的目的并不是传承中华优秀传统文化，而是坚定理想信念，②不选。<br>④：说法错误，教育在人的教化与培育上始终扮演重要角色，不是科技，④不选。<br>故本题选A。</span></div>
</div>

    """
    html2 = """
    <div class="stem-wraper" data-v-494b33d9="">
<p style="text-indent: 2em;">&nbsp;</p>
<p style="text-indent: 2em;">（二）</p>
<p style="text-indent: 2em;">现代文阅读Ⅱ</p>
<p style="text-indent: 2em;">阅读下面的文字，完成下面小题。</p>
<p style="text-indent: 2em;">&nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp;诗人</p>
<p style="text-indent: 2em;">&nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp;（英）毛姆</p>
<p style="text-indent: 2em;">我第一次读这些诗时才二十三岁，当时迷恋得手不释卷；他的诗句中有种激情，有种英雄的孤傲和斑斓的生命力，一下让我神魂颠倒。因为那些掷地有声的诗句和绕梁不绝的韵律已经和我美好的青春记忆交缠在一起，所以一直到今天，我读起它们来还会心跳加速。我一向认为卡利斯托·德·圣阿纳在西班牙语读者中的声望是他应得的。当年每个年轻人都能随口吟诵他的诗句，而我的朋友会无休无止地跟我讨论他疯狂的举动、狂热的演说（诗人之外他也是个政治家）、锐利的妙语和他的恋人们。</p>
<p style="text-indent: 2em;">但这些都是很多年以前的事了，四分之一个世纪以来，卡利斯托先生一直隐居在他的家乡埃西哈，不屑和这个再没有什么能让他感兴趣的世界为伍。正是我说要去那里的时候，迭戈·托雷表示愿意替我引见。</p>
<p style="text-indent: 2em;">“他现在看上去怎么样？”我问。</p>
<p style="text-indent: 2em;">“神采不凡。”</p>
<p style="text-indent: 2em;">“你有他的照片吗？”</p>
<p style="text-indent: 2em;">“有就好了。他三十五岁之后就拒绝面对镜头。他说他只想让后世见到他年轻时的样子。”</p>
<p style="text-indent: 2em;">我必须承认，这句话中所透露的虚荣让我觉得十分动人。我知道他年轻时极为俊美，当他意识到青春一去不返时，他创作了一首感人的十四行诗，从中你可以清楚读到曾经被如此爱慕的容颜终于逝去，他所领受的那阵刺痛是多么苦涩，多么冷酷。</p>
<p style="text-indent: 2em;">当我到达埃西哈的当晚，拿到那位大人物留给我的字条时，我是大为惊异的。他说，迭戈·托雷写信给他，提到了我的行程，如果我能在第二天上午十一点登门，会让他非常高兴。事已至此，除了第二天在指定时间造访，我好像也没有其他选择了。</p>
<p style="text-indent: 2em;">埃西哈也曾有过辉煌，很多白色的房子，石头大门上都有气势雄伟的纹章，因为此地虽僻远，但当年新世界的财富也曾源源涌来，那些勇闯美洲、满载而归的人都选择在此安度余生。卡利斯托先生就住在这样一栋房子里，拉了门铃之后我站在栏杆外，想到这宅邸的确配得上他，心里有些快意。这阔大的石门有种颓败的豪气，与张扬的诗人正相称。虽然我听见铃声穿透了屋子，但无人应答，我摇了第二次、第三次，终于，一个老妇来到了门口。</p>
<p style="text-indent: 2em;">“你要干吗？”她问。</p>
<p style="text-indent: 2em;">她的黑眼睛倒好看，但是情绪不佳，我猜她是在这里照顾老诗人的。我把名片递给她。</p>
<p style="text-indent: 2em;">“我跟你的主人有约。”</p>
<p style="text-indent: 2em;">她把大门打开，让我进去。她让我在那里等着，之后便丢下我上楼去了。这座建筑的各处比例都很大气，但油漆已经黯淡，地上的瓷砖多有碎裂，墙壁上还可见到多处灰泥大块大块地剥落。这里每样东西都散发着贫寒的气息，却看不出邋遢。院子中间有张桌子，两侧各放一张摇椅，桌上的报纸已经是半个月之前的了。我开始猜想在温暖的夏夜，坐在这里抽烟时，是怎样的梦幻充溢他的思绪。柱廊之下，墙上挂着一些西班牙的绘画，颜色暗沉，画艺拙劣。有几个积灰的雕花立橱四下立着，上面有修补过的瓷质盘碟。</p>
<p style="text-indent: 2em;">我开始猜想在温暖的夏夜，坐在这里抽烟时，是怎样的梦幻充溢他的思绪。这个场景，再加上我朦胧勾勒的种种联想，和这位浪漫诗人的形象太过相称，我几乎要被这个地方的气魄压倒。这种高贵的贫苦笼罩着他，其美好不亚于他年轻时的不可一世。但现在有些局促起来。我点了一支烟。我是照着时间来的，不知老先生是叫什么给耽搁了。这种寂静让人有些不安。</p>
<p style="text-indent: 2em;">我听见有声响，心跳快了起来。我现在有些激动了，等到看见他走下楼梯时，我屏住了呼吸。他一只手里有我的名片。这是位个子很高的老人，非常瘦削，皮肤是旧象牙的颜色。花白的头发依然很茂密，而浓密的眉毛依然是乌黑的，这让他的黑眼珠里闪过的火焰更添了一分严峻的气势。以他的年纪，眼神里依然保有那样的光芒，真是让人赞叹。他的鼻子是鹰钩鼻，嘴唇抿得紧紧的。他不带笑意的眼神落在我的身上，冷静地审视着我。他的衣服从上到下是黑色的，一只手中拿着一只宽边帽。在他的仪态中有种自在和高贵。他完全是我希望的样子，我看着他，终于懂得他是如何深入人们的头脑，触动他们的心灵的。他身上没有一寸不像个诗人。</p>
<p style="text-indent: 2em;">他进了院子，缓缓向我走来。他的眼睛也绝对像是鹰的眼睛。这对我来说，似乎是个重大的时刻，因为他就站在那里。看着这个西班牙过往伟大诗人的继承者，我想到了华美的埃雷拉，怀旧和感人的路易斯修士、神秘主义者圣十字若望和艰涩难懂的路易斯·德·贡戈拉。他是这条悠长传统的最后一人，他踩着诗界先辈的足迹丝毫不用汗颜。我莫名地在心里唱起了卡利斯托先生最有名的情诗，轻柔而动人。</p>
<p style="text-indent: 2em;">我很不好意思。还好我之前准备了该如何跟他打招呼。</p>
<p style="text-indent: 2em;">“大师，我这样一个外国人能和您结识真是万分荣幸。”</p>
<p style="text-indent: 2em;">他犀利的眼神中突然有笑意摇曳了一下，严厉的嘴唇也有那么一瞬间被微笑弯成弧线。</p>
<p style="text-indent: 2em;">“我不是诗人，先生，我是卖猪鬃刷子的。你弄错了，卡利斯托先生在隔壁。”</p>
<p style="text-indent: 2em;">我找错了地方。</p>
</div>
<div class="slave" data-v-494b33d9="">
<div class="slave-item" data-v-494b33d9="">
<div class="content" data-v-494b33d9=""><span class="analysis-prefix" data-v-494b33d9="">6</span><span data-v-494b33d9="">.</span><span data-v-494b33d9="">下列对本文相关内容的理解，正确的一项是（ ）</span></div>
<ul class="stem-options" data-v-494b33d9="">
<li data-v-494b33d9=""><span class="analysis-prefix" data-v-494b33d9="">A.</span><span data-v-494b33d9="">“我”觉得“诗人”年轻时极为俊美，三十五岁后不再拍照，有虚荣的成分，但事出有因，应该予以理解。</span></li>
<li data-v-494b33d9=""><span class="analysis-prefix" data-v-494b33d9="">B.</span><span data-v-494b33d9="">为了促成“我”和“诗人”的相见，迭戈·托雷给“诗人”写了一封信，并约定好了第二天登门造访的时间。</span></li>
<li data-v-494b33d9=""><span class="analysis-prefix" data-v-494b33d9="">C.</span><span data-v-494b33d9="">老妇人在“我”第三次摇门铃后出现，故意拖延开门<img src="http://zxhx-1302712961.cos.ap-shanghai.myqcloud.com/zyk/uploadfiles/wording/621585c56ca622396925f52a/image2.png" width="14px" height="19px" data-latex="$$">时间，看来他们经常被来访者打扰而“情绪不佳”。</span></li>
<li data-v-494b33d9=""><span class="analysis-prefix" data-v-494b33d9="">D.</span><span data-v-494b33d9="">听到“我”的介绍，“老诗人”“犀利的眼神中突然有笑意摇曳了一下”，说明他心里充满了对“我”的嘲笑。</span></li>
</ul>
</div>
<div class="slave-item" data-v-494b33d9="">
<div class="content" data-v-494b33d9=""><span class="analysis-prefix" data-v-494b33d9="">7</span><span data-v-494b33d9="">.</span><span data-v-494b33d9="">下列对本文艺术特色的分析鉴赏，不正确的一项是（ ）</span></div>
<ul class="stem-options" data-v-494b33d9="">
<li data-v-494b33d9=""><span class="analysis-prefix" data-v-494b33d9="">A.</span><span data-v-494b33d9="">“我”本来是去拜访一位神往已久的“诗人”，却遇到一个“卖猪鬃刷子的”。一雅一俗，反差巨大，令人捧腹。</span></li>
<li data-v-494b33d9=""><span class="analysis-prefix" data-v-494b33d9="">B.</span><span data-v-494b33d9="">文中两次写到“我”的心跳加快，今昔相连，前后呼应，互相映衬，突出“我”对“诗人”的崇敬和仰慕之情。</span></li>
<li data-v-494b33d9=""><span class="analysis-prefix" data-v-494b33d9="">C.</span><span data-v-494b33d9="">文中写“埃西哈”，白色的房子，雄伟的纹章，曾经的财富和满载而归的人们，都在暗喻此地曾经的辉煌。</span></li>
<li data-v-494b33d9=""><span class="analysis-prefix" data-v-494b33d9="">D.</span><span data-v-494b33d9="">这篇小说采用第一人称“我”作为叙述者，增强了故事的可信性；情节曲折生动，语言幽默风趣，引人入胜。</span></li>
</ul>
</div>
<div class="slave-item" data-v-494b33d9="">
<div class="content" data-v-494b33d9=""><span class="analysis-prefix" data-v-494b33d9="">8</span><span data-v-494b33d9="">.</span><span data-v-494b33d9="">小说结尾出乎意料，又合乎情理。其实文中有多处暗示，请找出来，并略加分析。</span></div>
</div>
<div class="slave-item" data-v-494b33d9="">
<div class="content" data-v-494b33d9=""><span class="analysis-prefix" data-v-494b33d9="">9</span><span data-v-494b33d9="">.</span><span data-v-494b33d9="">层层渲染是本文的一大特色，请分析一下作者是如何层层渲染“我”对“诗人”的崇拜之情的。并分析这样写的作用。</span></div>
</div>
</div>
<div class="topic-analysis" data-v-494b33d9="">
<div class="topic-analysis-content" data-v-494b33d9=""><span class="analysis-prefix" data-v-494b33d9="">【答案】</span><span data-v-494b33d9="">6.&nbsp;&nbsp;&nbsp;&nbsp;A<br>7.&nbsp;&nbsp;&nbsp;&nbsp;C<br>8.&nbsp;&nbsp;&nbsp;&nbsp;①没有照片，“我”不认识诗人，使得误会有发生的合理性；②摇了多次门铃无人应答，递上名片后，长时间的等待，说明主人事先并不知晓有人前来拜访；③住所破败而寒酸，盘碟低劣破旧，说明主人的社会地位并不高，不太可能是闻名遐迩的诗人；④桌上的报纸是半个月前的，墙上的绘画画艺拙劣，说明主人不太可能是一位有知识的人。⑤“我跟你的主人有约”没有说“主人”的名字。为结尾出现卖猪鬃刷子的主人出现合理。⑥“很多白色的房子，石头大门上都有气势雄伟的纹章” “卡利斯托先生就住在这样一栋房子里”许多相似的房子不易分辨，容易弄错。<br>9.&nbsp;&nbsp;&nbsp;&nbsp;渲染：①开篇写年轻时读诗的感受，突出“我”对“诗人”的着迷；②等待会见时，“我”对“诗人”的处境做出种种联想；③初见时，对“诗人”外貌的描写，突出“我”对“诗人”的迷恋；④开口打招呼前，“我”激动的心情以及心中对他的赞美。<br>作用：反复强调“我”对诗人的迷恋和崇拜；为结尾处的转折蓄势，突出了文章的戏剧效果。<br></span></div>
<div class="topic-analysis-content" data-v-494b33d9=""><span class="analysis-prefix" data-v-494b33d9="">【解析】</span><span data-v-494b33d9="">6.&nbsp;&nbsp;&nbsp;&nbsp;本题考查学生理解分析文章内容的能力。<br>B.“并约定好了第二天登门造访的时间”错误。结合“拿到那位大人物留给我的字条时，我是大为惊异的。他说，迭戈·托雷写信给他，提到了我的行程，如果我能在第二天上午十一点登门，会让他非常高兴”，可见迭戈·托雷的信并没有约定好拜访时间。<br>C.“故意拖延”于文无据。“情绪不佳”并无明确的原因。结合“虽然我听见铃声穿透了屋子，但无人应答，我摇了第二次、第三次，终于，一个老妇来到了门口”“‘你要干吗？’她问”“她的黑眼睛倒好看，但是情绪不佳，我猜她是在这里照顾老诗人的。我把名片递给她”“我跟你的主人有约”“她把大门打开，让我进去。她让我在那里等着，之后便丢下我上楼去了”可知。<br>D.“说明他心里充满对‘我’的嘲笑”错误。结合“他犀利的眼神中突然有笑意摇曳了一下，严厉的嘴唇也有那么一瞬间被微笑弯成弧线”“我不是诗人，先生，我是卖猪鬃刷子的。你弄错了，卡利斯托先生在隔壁”可知没有嘲笑之意。<br>故选A。<br>7.&nbsp;&nbsp;&nbsp;&nbsp;本题考查学生分析鉴赏文章艺术特色的能力。<br>C. “暗喻”错误，这里没有比喻的成分，应是在暗示这个地方曾经的不平凡。<br>故选C。<br>8.&nbsp;&nbsp;&nbsp;&nbsp;本题考查学生分析小说的情节结构的能力。<br>主要考查情节安排的技巧。小说的结局出人意料，如果前文没有暗示，转折便不甚合理了。<br>如伏笔或暗示为没有诗人的“照片”，结合“你有他的照片吗？”“‘有就好了。他三十五岁之后就拒绝面对镜头。他说他只想让后世见到他年轻时的样子。’”如果有照片，“我”便不会认错人，也就没有了后文的阴差阳错找错人的内容。所以作者设置为没有照片，这才使得后文的误会变得合理。其他几处可以依此类推。<br>如没有具体的约定的时间，结合“当我到达埃西哈的当晚，拿到那位大人物留给我的字条时，我是大为惊异的。他说，迭戈·托雷写信给他，提到了我的行程，如果我能在第二天上午十一点登门，会让他非常高兴。事已至此，除了第二天在指定时间造访，我好像也没有其他选择了”。导致对后面一系列出乎意料没在意。<br>如摇动多次门铃没人开以及老妇的问话，“拉了门铃之后我站在栏杆外，想到这宅邸的确配得上他，心里有些快意。这阔大的石门有种颓败的豪气，与张扬的诗人正相称。虽然我听见铃声穿透了屋子，但无人应答，我摇了第二次、第三次，终于，一个老妇来到了门口”“你要干吗？”她问。可见没有约客的准备。<br>如环境场景以及住室的布置安排，以及旧报纸，“但油漆已经黯淡，地上的瓷砖多有碎裂，墙壁上还可见到多处灰泥大块大块地剥落。这里每样东西都散发着贫寒的气息，却看不出邋遢。院子中间有张桌子，两侧各放一张摇椅，桌上的报纸已经是半个月之前的了”“柱廊之下，墙上挂着一些西班牙的绘画，颜色暗沉，画艺拙劣。有几个积灰的雕花立橱四下立着，上面有修补过的瓷质盘碟”。可见不像诗人居处和风格。<br>9.&nbsp;&nbsp;&nbsp;&nbsp;本题考查学生分析作品的表现手法及其作用。<br>抓住“我”对“诗人”的“崇拜之情”来分析即可。分析时，要抓住“我”的言行，分析言行背后的心理因素和情感倾向。<br>第一处渲染在第1段“我第一次读这些诗时才二十三岁，当时迷恋得手不释卷；他的诗句中有种激情，有种英雄的孤傲和斑斓的生命力，一下让我神魂颠倒。因为那些掷地有声的诗句和绕梁不绝的韵律已经和我美好的青春记忆交缠在一起，所以一直到今天，我读起它们来还会心跳加速。我一向认为卡利斯托·德·圣阿纳在西班牙语读者中的声望是他应得的。当年每个年轻人都能随口吟诵他的诗句，而我的朋友会无休无止地跟我讨论他疯狂的举动、狂热的演说（诗人之外他也是个政治家）、锐利的妙语和他的恋人们”，开篇写年轻时读诗的感受，突出“我”对“诗人”的着迷。<br>第二处渲染是第13段“我开始猜想在温暖的夏夜，坐在这里抽烟时，是怎样的梦幻充溢他的思绪”，14段“这个场景，再加上我朦胧勾勒的种种联想，和这位浪漫诗人的形象太过相称，我几乎要被这个地方的气魄压倒。这种高贵的贫苦笼罩着他，其美好不亚于他年轻时的不可一世。但现在有些局促起来。我点了一支烟。我是照着时间来的，不知老先生是叫什么给耽搁了。这种寂静让人有些不安”。可见等待会见时，“我”对“诗人”的处境做出种种联想；<br>第三处渲染是“我听见有声响，心跳快了起来。我现在有些激动了，……我屏住了呼吸。……这是位个子很高的老人，……以他的年纪，眼神里依然保有那样的光芒，真是让人赞叹。……在他的仪态中有种自在和高贵。他完全是我希望的样子，我看着他，终于懂得他是如何深入人们的头脑，触动他们的心灵的。他身上没有一寸不像个诗人”，初见时，对“诗人”外貌的描写，突出“我”对“诗人”的迷恋。<br>第四次渲染“因为他就站在那里。看着这个西班牙过往伟大诗人的继承者，我想到了华美的埃雷拉，怀旧和感人的路易斯修士、神秘主义者圣十字若望和艰涩难懂的路易斯·德·贡戈拉。他是这条悠长传统的最后一人，他踩着诗界先辈的足迹丝毫不用汗颜。我莫名地在心里唱起了卡利斯托先生最有名的情诗，轻柔而动人”，可见开口打招呼前，“我”激动的心情以及心中对他的赞美。<br>作用：前后相映，突出了“我”对诗人的仰慕崇拜之情，反复强调“我”对诗人的迷恋和崇拜；为结尾处的转折蓄势，突出了文章的戏剧效果，具有出人意料又在情理之中的情节特点，或许正是因为“我”先入为主的迷恋引发了一系列不符合常理却没有察觉，具有先扬后抑的对比效果，令读者恍然大悟，加深了对诗人的印象，未见其人但已然了解，似乎比见着记忆还深刻。<br></span></div>
</div>
    """
    html3 = """
        <div class="stem-wraper" data-v-e0919bfe=""><span class="stem" data-v-e0919bfe="">林树下线是一种特殊的地理生态现象。下表示意“岷江上游林树下线与坡向的关系及变化”，调查发现，该地10年间聚落区的林树下线向低海拔地区扩张距离比非聚落区大70米。据此完成11～12题。<br><img style="vertical-align: middle; max-width: 100%;" src="http://82.156.91.175:11088/ser_static/0/new_image9006b211b12b470d8d3c5f05d7b77945.png"><br>11.与其他坡向相比，东南坡林树下线高度特点的主要原因是<br>A.降水丰沛，气候湿润 B.土层深厚，土壤肥沃<br>C.地形平缓，落差较小 D.光照充足，蒸发量大<br>12.推测10年间聚落区的林树下线向低海拔地区迅速扩张的主要原因是<br>A.开垦荒地 B.退耕还林 C.土壤退化 D.水土流失<br>【答案】<br></span></div>
    <div class="topic-analysis" data-v-e0919bfe="">
    <div class="topic-analysis-content" data-v-e0919bfe=""><span data-v-e0919bfe="">11.D <br>12.B</span></div>
    <div class="topic-analysis-content" data-v-e0919bfe=""><span class="analysis-prefix" data-v-e0919bfe="">【解析】<br></span><span data-v-e0919bfe="">11.从表格可知，东南坡林树下线高度为最大。降水丰沛，气候湿润，会使得林树下线降低，A选项错误。土壤肥沃，植被生长会更为茂密，林树下线会降低，B选项错误。地形与林带分布影响相对较小，与之无关，选项错误。东南坡为阳坡，光照充足，蒸发量更大，使得林树下线的高度偏高，符合题意，D选项正确。<br>12.10年间，聚落区的林树下线向低海拔迅速扩张，说明其森林的范围在扩大。开垦荒地会使森林的范围缩小，林树下线会上升，A选项错误。退耕还林会使森林范围扩大，人工退耕还林会使得林树下线迅速扩张，B选项正确。土壤退化，森林适宜的范围缩小，林树下线会上升，C选项错误。水土流失加剧，使得森林范围缩小，林树下线上升，D选项错误。</span></div>
    </div>
        """
    html4 = """
<div class="stem-wraper" data-v-494b33d9="">
<div class="stem-wraper" data-v-494b33d9="">海绵城市是指城市能够像海绵一样，在下雨时吸水、蓄水；需要时，将蓄存的水“释放”并加以利用。雨季集中在夏秋两季的重庆，每当雨水降临，别有一番“雨打芭蕉”“巴山夜雨”的风情。重庆大胆探索山地海绵城市（如下左图）建设经验和实践路径，下面右图为水循环过程示意图。据此完成1-2小题。</div>
<div class="stem-wraper" data-v-494b33d9="">&nbsp;</div>
<div class="stem-wraper" data-v-494b33d9="">1.图中表示ABCDE环节依次是（)</div>
<div class="stem-wraper" data-v-494b33d9="">A.蒸发、水汽输送、降水、地下径流、下渗</div>
<div class="stem-wraper" data-v-494b33d9="">B.蒸腾、水汽输送、降水、地表径流、下渗</div>
<div class="stem-wraper" data-v-494b33d9="">C.蒸发、水汽输送、降水、地表径流、下渗</div>
<div class="stem-wraper" data-v-494b33d9="">D.蒸腾、水汽输送、降水、地下径流、下渗</div>
<div class="stem-wraper" data-v-494b33d9="">2.海绵城市建设使得重庆市内涝频率显著下降的原因是()</div>
<div class="stem-wraper" data-v-494b33d9="">A.水域面积增大，蓄洪量提升</div>
<div class="stem-wraper" data-v-494b33d9="">B.水体相互连通，泄洪能力提高</div>
<div class="stem-wraper" data-v-494b33d9="">C.增强气候调节，暴雨频率下降</div>
<div class="stem-wraper" data-v-494b33d9="">D.改变地表形态，城市洼地增多</div>
<div class="stem-wraper" data-v-494b33d9="">【答案】1.A 2.B</div>
<div class="stem-wraper" data-v-494b33d9="">【解析】1.略 2.略</div>
</div>
    """
    hml4 = """
       <p style="text-indent: 2em;">①如果不为求富贵，那么，人为什么要上大学呢？大学对人最大的价值和意义在于：一所大学塑造了一个人的思维方式、气质格局、生活态度和价值观。它从根本上定义了一个人的人生。概括说来，上大学重要的是要获得四个“识”。</p>
<p style="text-indent: 2em;">②第一个“识”是知识。在古希腊传说中，普罗米修斯从奥林匹斯山上盗火给人类，触怒了宙斯，被锁在高加索山的悬崖上，忍受无穷无尽的折磨——宙斯每天派一只鹰去吃他的肝，又让他的肝每天重新长上，使他日日承受被恶鹰啄食肝脏的痛苦。而普罗米修斯所盗取的火是对知识的隐喻。在阿喀琉斯了解到的传说中，普罗米修斯向人类介绍了艺术、写作、数学、天文、建筑和医学。换句话说，普罗米修斯从天上给人间带来了今天我们称之为“通识教育”的内容，从而使人类摆脱了愚昧和无知，尽管他和人类都为此付出了可怕的代价——宙斯为了惩罚人类，将潘多拉的盒子放在了人间。真正的知识，是普罗米修斯带给人类的最珍责的礼物，它能擦亮你的眼睛，让你能够分辨清楚善和恶，看到你原先不曾看到的风景。但与此同时，知识本身也会潜在地带来危险和灾祸。</p>
<p style="text-indent: 2em;">③仅有知识是不够的，大学还将带给你第二个“识”：见识。真正的见识是洞察力、判断力和感知力的完美结合。它是当刘邦进入咸阳后，萧何所干的第一件事——把秦朝的地图、书籍和档案资料统统收集起来；它是诸葛亮在隆中躬耕之际就清晰看到的日后天下三分的图景；它是王选在20世纪70年代确立的汉字激光照排研发目标；它是任正非早在2012年就启动的“鸿蒙计划”……之所以大学能带给你见识，首要的因素当然是人，是大学里的白发的先生和你周围的伙伴，他们用他们的见识和人生体验开启了你的见识，帮助你构建起一种更宽宏大量的人生观念。</p>
<p style="text-indent: 2em;">④第三，光有知识和见识还不够，人还要有胆识。它指的并不是“清华北大不如胆子大”的胆大——那不过是无知和浅陋，而是“卒然临之而不惊，无故加之而不怒”的大勇。人之所以能具备这种大勇，是因为“其所抉持者甚大，而其志甚远也。”正是因为有了这样的高远之志，一个人才能做到面对危险时毫不畏惧，“虽千万人，吾往矣！”面对困难时毫不退缩，坚持到底；面对压力诱惑时“通识”“不惑，不忧，不惧”。归根到底，一个人的勇气来源于信念，事无不可对人言，相信自己所做的是正确的事，自然没有丝毫犹豫和忧惧。今天的大学，还要在一定程度上加强学生的“胆识”教育。</p>
<p style="text-indent: 2em;">⑤第四，也许是最重要的，上述知识、见识和胆识加在一起，形成最后一个“识”：认识。首先是认识你自己，其次是认识他人。人是社会性动物。只认识自身是远远不够的，还必须认识他人，和他人发生联系。孟子说：“仁也者，人也。合而言之，道也。”这个“仁”，指的就是人和人之间的关系，所以“仁”字从“二人”。只有在和他人的联系之中，“仁”才能得以实现。实际上，这恰恰是现代教育特别重视培养孩子的社交能力的原因所在。最后是认识世界。我和世界的关系是什么？我在世界中的位置是什么？世界对于我的意义是什么？想清楚这些根本性的问题，才能在我们脆弱而干涸的心中注入力量，帮助我们战胜人生途中的种种困难和挑战。</p>
<p style="text-indent: 2em;">⑥蔡元培先生就任北大校长后，曾语重心长地告诫说：“大学者，研究高深学问者也……果欲达其做官发财之目的……又何必来此大学？所以诸君须抱定宗旨，为求学而来。”蔡先生这些话是一百多年前说的，言犹在耳，依然振聋发聩。</p>
<p style="text-align: right;">（摘编自秦春华《为什么上大学》，《光明日报》2021年08月31日）</p>
<p>1. 下列关于原文内容的理解和分析，不正确的一项是（ ）</p>
<p>A. 大学能够从根本上定义一个人的人生，能够塑造一个人的思维方式、气质格局、生活态度和价值观。</p>
<p>B. 知识如同普罗米修斯盗给人类的火，涉及艺术、写作、数学、天文、建筑和医学等，完全有益于人类。</p>
<p>C. 洞察力、判断力和感知力的完美结合才是真正的见识，大学里的先生和周围的伙伴会帮助学子开启见识。</p>
<p>D. 要在脆弱而干涸的心中注入力量，战胜人生途中的困难和挑战，就应该认识世界，弄清一些根本性问题。</p>
<p>2. 下列对原文论证的相关分析，不正确的一项是（ ）</p>
<p>A. 文章第三段运用例证法，以萧何、诸葛亮、王选、任正非为例，阐述了“见识”的内涵。</p>
<p>B. 文章第四段运用引证法，“虽千万人，吾往矣”等名言警语的引入，强调了人要有胆识。</p>
<p>C. 文章用“如果不为求富贵”“仅有知识是不够的”等对观点表述作出限制，立论非常审慎。</p>
<p>D. 文章总体采用层进式的结构方式，论证了上大学的最大价值意义，论证周密，条理井然。</p>
<p>3. 根据原文内容，下列说法正确的一项是（ ）</p>
<p>A. 人们上大学，重要的是在学习中获得知识、见识、胆识和认识，其中认识是最重要的。</p>
<p>B. 今天的大学，缺少胆识教育，学生缺乏“卒然临之而不惊，无故加之而不怒”的大勇。</p>
<p>C. 现代教育特别重视培养孩子们的社交能力，其根本原因就是要实现孟子所倡导的仁爱。</p>
<p>D. 一百多年过去了，蔡元培先生“抱定宗旨，为求学而来”的告诫，仍然值得我们警醒。</p>
<p>【1~3题答案】</p>
<p>【答案】</p>
<p>1. B</p>
<p>2. D</p>
<p>3. D</p>
<p>【解析】</p>
<p>【1题详解】</p>
<p>本题考查学生筛选并整合文本信息的能力。B.“完全有益于人类”说法错误，原文为“但与此同时，知识本身也会潜在地带来危险和灾祸”，所以并不是完全有益于人类。故选B。</p>
<p>【2题详解】</p>
<p>本题考查学生分析论点、论据和论证方法的能力。D.“文章总体采用层进式的结构方式”说法错误，文章总体上应该是采用总分总的结构，主体部分采用层进式的结构方式。故选D。</p>
<p>【3题详解】</p>
<p>本题考查学生分析概括作者的观点态度的能力。A.“其中认识是最重要的”说法过于绝对，原文为“第四，也许是最重要的，上述知识、见识和胆识加在一起，形成最后一个‘识’：认识”，说的是也许是最重要的。B.“今天的大学，缺少胆识教育，学生缺乏‘卒然临之而不惊，无故加之而不怒’的大勇”于文无据，原文只说“今天的大学，还要在一定程度上加强学生的‘胆识’教育”，并没有说今天的大学，缺少胆识教育，也没有说学生缺乏“卒然临之而不惊，无故加之而不怒”的大勇。C.“其根本原因就是要实现孟子所倡导的仁爱”说法错误，原文为“实际上，这恰恰是现代教育特别重视培养孩子的社交能力的原因所在”，并没有说是根本原因。故选D。</p>
       """

    aa = single_parse(str(hml4), "小题多问类", "62b269e76c6aff227934605e", "语文")
    pprint(aa)
    #


    # print("原始：")
    # one_item = css_label_wash(htm2)
    # one_item = re.sub("</?p>|<h[12345]", "", one_item)
    #
    # # one_item = base642img(one_item, wordid)
    # print("去css：", one_item)


